# Oracle

> JDBC Oracle Sink Connector

### Description[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/sink/Oracle#description) <a href="#description" id="description"></a>

Write data through jdbc. Support Batch mode and Streaming mode, support concurrent writing, support exactly-once semantics (using XA transaction guarantee).

### Key Features[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/sink/Oracle#key-features) <a href="#key-features" id="key-features"></a>

* [x] &#x20;exactly-once
* [x] &#x20;cdc

> Use `Xa transactions` to ensure `exactly-once`. So only support `exactly-once` for the database which is support `Xa transactions`. You can set `is_exactly_once=true` to enable it.

### Supported DataSource Info[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/sink/Oracle#supported-datasource-info) <a href="#supported-datasource-info" id="supported-datasource-info"></a>

<table><thead><tr><th>Datasource</th><th>Supported Versions</th><th>Driver</th><th data-hidden>Url</th><th data-hidden>Maven</th></tr></thead><tbody><tr><td>Oracle</td><td>Different dependency version has different driver class.</td><td>oracle.jdbc.OracleDriver</td><td>jdbc:oracle:thin:@datasource01:1523:xe</td><td><a href="https://mvnrepository.com/artifact/com.oracle.database.jdbc/ojdbc8">https://mvnrepository.com/artifact/com.oracle.database.jdbc/ojdbc8</a></td></tr></tbody></table>

### Data Type Mapping[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/sink/Oracle#data-type-mapping) <a href="#data-type-mapping" id="data-type-mapping"></a>

| Oracle Data Type                                                                    | Nexus Data Type |
| ----------------------------------------------------------------------------------- | --------------- |
| INTEGER                                                                             | INT             |
| FLOAT                                                                               | DECIMAL(38, 18) |
| NUMBER(precision <= 9, scale == 0)                                                  | INT             |
| NUMBER(9 < precision <= 18, scale == 0)                                             | BIGINT          |
| NUMBER(18 < precision, scale == 0)                                                  | DECIMAL(38, 0)  |
| NUMBER(scale != 0)                                                                  | DECIMAL(38, 18) |
| BINARY\_DOUBLE                                                                      | DOUBLE          |
| <p>BINARY\_FLOAT<br>REAL</p>                                                        | FLOAT           |
| <p>CHAR<br>NCHAR<br>NVARCHAR2<br>VARCHAR2<br>LONG<br>ROWID<br>NCLOB<br>CLOB<br></p> | STRING          |
| DATE                                                                                | DATE            |
| <p>TIMESTAMP<br>TIMESTAMP WITH LOCAL TIME ZONE</p>                                  | TIMESTAMP       |
| <p>BLOB<br>RAW<br>LONG RAW<br>BFILE</p>                                             | BYTES           |

### Options[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/sink/Oracle#options) <a href="#options" id="options"></a>

| Name                                            | Type    | Required | Default                          | Description                                                                                                                                                                                                                                         |
| ----------------------------------------------- | ------- | -------- | -------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| url                                             | String  | Yes      | -                                | The URL of the JDBC connection. Refer to a case: jdbc:oracle:thin:@datasource01:1523:xe                                                                                                                                                             |
| driver                                          | String  | Yes      | -                                | <p>The jdbc class name used to connect to the remote data source,<br>if you use Oracle the value is <code>oracle.jdbc.OracleDriver</code>.</p>                                                                                                      |
| user                                            | String  | No       | -                                | Connection instance user name                                                                                                                                                                                                                       |
| password                                        | String  | No       | -                                | Connection instance password                                                                                                                                                                                                                        |
| query                                           | String  | No       | -                                | Use this sql write upstream input datas to database. e.g `INSERT ...`,`query` have the higher priority                                                                                                                                              |
| database                                        | String  | No       | -                                | <p>Use this <code>database</code> and <code>table-name</code> auto-generate sql and receive upstream input datas write to database.<br>This option is mutually exclusive with <code>query</code> and has a higher priority.</p>                     |
| table                                           | String  | No       | -                                | <p>Use database and this table-name auto-generate sql and receive upstream input datas write to database.<br>This option is mutually exclusive with <code>query</code> and has a higher priority.</p>                                               |
| primary\_keys                                   | Array   | No       | -                                | This option is used to support operations such as `insert`, `delete`, and `update` when automatically generate sql.                                                                                                                                 |
| support\_upsert\_by\_query\_primary\_key\_exist | Boolean | No       | false                            | Choose to use INSERT sql, UPDATE sql to process update events(INSERT, UPDATE\_AFTER) based on query primary key exists. This configuration is only used when database unsupport upsert syntax. **Note**: that this method has low performance       |
| connection\_check\_timeout\_sec                 | Int     | No       | 30                               | The time in seconds to wait for the database operation used to validate the connection to complete.                                                                                                                                                 |
| max\_retries                                    | Int     | No       | 0                                | The number of retries to submit failed (executeBatch)                                                                                                                                                                                               |
| batch\_size                                     | Int     | No       | 1000                             | <p>For batch writing, when the number of buffered records reaches the number of <code>batch\_size</code> or the time reaches <code>batch\_interval\_ms</code><br>, the data will be flushed into the database</p>                                   |
| batch\_interval\_ms                             | Int     | No       | 1000                             | For batch writing, when the number of buffers reaches the number of `batch_size` or the time reaches `batch_interval_ms`, the data will be flushed into the database                                                                                |
| is\_exactly\_once                               | Boolean | No       | false                            | <p>Whether to enable exactly-once semantics, which will use Xa transactions. If on, you need to<br>set <code>xa\_data\_source\_class\_name</code>.</p>                                                                                              |
| generate\_sink\_sql                             | Boolean | No       | false                            | Generate sql statements based on the database table you want to write to.                                                                                                                                                                           |
| xa\_data\_source\_class\_name                   | String  | No       | -                                | <p>The xa data source class name of the database Driver, for example, Oracle is <code>oracle.jdbc.xa.client.OracleXADataSource</code>, and<br>please refer to appendix for other data sources</p>                                                   |
| max\_commit\_attempts                           | Int     | No       | 3                                | The number of retries for transaction commit failures                                                                                                                                                                                               |
| transaction\_timeout\_sec                       | Int     | No       | -1                               | <p>The timeout after the transaction is opened, the default is -1 (never timeout). Note that setting the timeout may affect<br>exactly-once semantics</p>                                                                                           |
| auto\_commit                                    | Boolean | No       | true                             | Automatic transaction commit is enabled by default                                                                                                                                                                                                  |
| properties                                      | Map     | No       | -                                | <p>Additional connection configuration parameters,when properties and URL have the same parameters, the priority is determined by the<br>specific implementation of the driver. For example, in MySQL, properties take precedence over the URL.</p> |
| common-options                                  |         | No       | -                                | Sink plugin common parameters, please refer to [Sink Common Options](/data-integration-with-nexus/nexus-elements/connectors/sink/sink-common-options.md) for details                                                                                |
| schema\_save\_mode                              | Enum    | No       | CREATE\_SCHEMA\_WHEN\_NOT\_EXIST | Before the synchronous task is turned on, different treatment schemes are selected for the existing surface structure of the target side.                                                                                                           |
| data\_save\_mode                                | Enum    | No       | APPEND\_DATA                     | Before the synchronous task is turned on, different processing schemes are selected for data existing data on the target side.                                                                                                                      |
| custom\_sql                                     | String  | No       | -                                | When data\_save\_mode selects CUSTOM\_PROCESSING, you should fill in the CUSTOM\_SQL parameter. This parameter usually fills in a SQL that can be executed. SQL will be executed before synchronization tasks.                                      |
| enable\_upsert                                  | Boolean | No       | true                             | Enable upsert by primary\_keys exist, If the task has no key duplicate data, setting this parameter to `false` can speed up data import                                                                                                             |

#### Tips[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/sink/Oracle#tips) <a href="#tips" id="tips"></a>

> If partition\_column is not set, it will run in single concurrency, and if partition\_column is set, it will be executed in parallel according to the concurrency of tasks.

### Task Example[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/sink/Oracle#task-example) <a href="#task-example" id="task-example"></a>

#### Simple:[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/sink/Oracle#simple) <a href="#simple" id="simple"></a>

> This example defines a Nexus synchronization task that automatically generates data through FakeSource and sends it to JDBC Sink. FakeSource generates a total of 16 rows of data (row\.num=16), with each row having two fields, name (string type) and age (int type). The final target table is test\_table will also be 16 rows of data in the table. Before run this job, you need create database test and table test\_table in your Oracle.&#x20;

```
# Defining the runtime environment
env {
  parallelism = 1
  job.mode = "BATCH"
}

source {
  FakeSource {
    parallelism = 1
    result_table_name = "fake"
    row.num = 16
    schema = {
      fields {
        name = "string"
        age = "int"
      }
    }
  }
  # If you would like to get more information about how to configure Nexus and see full list of source plugins,
  # please go to source page
}

transform {
  # If you would like to get more information about how to configure Nexus and see full list of transform plugins,
    # please go to transform page
}

sink {
    jdbc {
        url = "jdbc:oracle:thin:@datasource01:1523:xe"
        driver = "oracle.jdbc.OracleDriver"
        user = root
        password = 123456
        query = "INSERT INTO TEST.TEST_TABLE(NAME,AGE) VALUES(?,?)"
     }
  # If you would like to get more information about how to configure Nexus and see full list of sink plugins,
  # please go to sink page
}
```

#### Generate Sink SQL[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/sink/Oracle#generate-sink-sql) <a href="#generate-sink-sql" id="generate-sink-sql"></a>

> This example not need to write complex sql statements, you can configure the database name table name to automatically generate add statements for you

```
sink {
    Jdbc {
        url = "jdbc:oracle:thin:@datasource01:1523:xe"
        driver = "oracle.jdbc.OracleDriver"
        user = root
        password = 123456
        
        generate_sink_sql = true
        database = XE
        table = "TEST.TEST_TABLE"
    }
}
```

#### Exactly-once :[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/sink/Oracle#exactly-once-) <a href="#exactly-once" id="exactly-once"></a>

> For accurate write scene we guarantee accurate once

```
sink {
    jdbc {
        url = "jdbc:oracle:thin:@datasource01:1523:xe"
        driver = "oracle.jdbc.OracleDriver"
    
        max_retries = 0
        user = root
        password = 123456
        query = "INSERT INTO TEST.TEST_TABLE(NAME,AGE) VALUES(?,?)"
    
        is_exactly_once = "true"
    
        xa_data_source_class_name = "oracle.jdbc.xa.client.OracleXADataSource"
    }
}
```

#### CDC(Change Data Capture) Event[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/sink/Oracle#cdcchange-data-capture-event) <a href="#cdcchange-data-capture-event" id="cdcchange-data-capture-event"></a>

> CDC change data is also supported by us In this case, you need config database, table and primary\_keys.

```
sink {
    jdbc {
        url = "jdbc:oracle:thin:@datasource01:1523:xe"
        driver = "oracle.jdbc.OracleDriver"
        user = root
        password = 123456
        
        generate_sink_sql = true
        # You need to configure both database and table
        database = XE
        table = "TEST.TEST_TABLE"
        primary_keys = ["ID"]
        schema_save_mode = "CREATE_SCHEMA_WHEN_NOT_EXIST"
        data_save_mode="APPEND_DATA"
    }
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.selfuel.digital/data-integration-with-nexus/nexus-elements/connectors/sink/oracle.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
